Advertisement
metalx1000

BASH script exit on error

Nov 9th, 2022
1,487
0
Never
Not a member of Pastebin yet? Sign Up, it unlocks many cool features!
Bash 1.42 KB | Source Code | 0 0
  1. #!/bin/bash
  2. ######################################################################
  3. #Copyright (C) 2022  Kris Occhipinti
  4. #https://filmsbykris.com
  5.  
  6. #This program is free software: you can redistribute it and/or modify
  7. #it under the terms of the GNU General Public License as published by
  8. #the Free Software Foundation, either version 3 of the License, or
  9. #(at your option) any later version.
  10.  
  11. #This program is distributed in the hope that it will be useful,
  12. #but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. #MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14. #GNU General Public License for more details.
  15.  
  16. #You should have received a copy of the GNU General Public License
  17. #along with this program.  If not, see <http://www.gnu.org/licenses/>.
  18. ######################################################################
  19.  
  20. #this script has an error function that will display a message
  21. #and exit the script even from sub processes
  22.  
  23. red=`echo -en "\e[31m"`
  24. normal=`echo -en "\e[0m"`
  25.  
  26. # fatal uses SIGUSR1 to allow clean fatal errors
  27. trap "exit 1" 10
  28. PROC=$$
  29.  
  30. function error(){
  31.   echo -e "${red}$@${normal}" >&2
  32. #  exit 1
  33.   kill -10 $PROC
  34. }
  35.  
  36. [[ "$1" ]] || error "Error:\nInput file needed\nExample: $0 'file.txt'"
  37. [[ -f "$1" ]] || error "'${1}' file does not exist."
  38.  
  39. [[ "$2" ]] || (echo "Thank you for your input";error "'$1' exists";echo "Exiting Script")
  40.  
  41. echo "This should never output"
  42.  
Tags: error BASH
Advertisement
Add Comment
Please, Sign In to add comment
Advertisement